#ifndef RNASECSTR_H
#define RNASECSTR_H

/*parameters*/
#define NMAX 300
#define INF INT_MAX/2
#define GUbond -1
#define AUbond -1
#define CGbond -1
#define THRESHOLD 3          // for i and j to basepair, |i-j| >= THRESHOLD

// around double to integer
#define round(x) ((x)>=0?(long)((x)+0.5):(long)((x)-0.5))

/*prototypes for rnaSecStr.c*/
extern void error(char *);
extern int guPair(char, char);
extern int auPair(char, char);
extern int cgPair(char, char);
extern int a(int, int, char *);
extern int basePair(char, char);
extern int watsonCrick(char, char);
extern void printSecStrListAsString(char*);
extern int validNucleotideString(char*);
extern int preValidSecStr(char*, char*);
extern char* initialEmptySecStr(int);
extern char* getInitialSecStr(char*);
#endif

