#ifndef STRUCT_H
#define STRUCT_H
#include "../lib/rnaSecStr.h"

/*
 * definition of structure
 */
//list to stock the base pair
typedef struct item {
	int x;
	int y;
	struct item *next;
} item;

typedef struct list {
	item *first;
	int size;
} list;
//list to stock the different secondary structure
typedef struct item_ss {
	char* ss;
	double energy;
	int nb;
	struct item_ss* next;
} item_ss;
typedef struct list_ss {
	struct item_ss* first;
	int size;
} list_ss;
//set of data return by the function nextConfiguration
typedef struct configuration {
	int flag;
	char* secStr;
	double energy;
	list* L;
	int* h;
	double* g;
	char** lss;
	int size;
} configuration;
//set of data return by the function wangLandau
typedef struct wl {
	int num;
	double* g;
	int* h;
	char** lss;
	int size;
} wl;
/*
 * prototypes for struct.c
 */
extern void print_char(char*);
extern void print_int(int*, int);
extern void print_double(double*, double, int);
extern char* copyTo_char(char*);
extern int checkThreshold(char*);
extern int compare2String(char*, char*);
extern list* init_list();
extern int get_list_x(list*, int);
extern int get_list_y(list*, int);
extern int set_list_x(list*, int, int);
extern int set_list_y(list*, int, int);
extern void add_list_item(list*, int, int);
extern void remove_list_item(list*, int);
extern list* copy_list(list*);
extern void print_list(list*);
extern list* set_list(char*);
extern void free_list(list* l);
extern int* new_h(int*, int);
extern double* new_g(double*, int, double);
extern char** new_lss(char**, int);
extern void print_list_ss(list_ss*);
extern void free_list_ss(list_ss*);
extern list_ss* init_list_ss(void);

#endif
